﻿<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta content="text/html; charset=utf-8" http-equiv="Content-Type" />
<title>Further Information</title>
<link href="style.css" rel="stylesheet" type="text/css" />
</head>

<body>

<h2><a name="information">Further Information</a></h2>
<p>Elsevier (aka Morgan Kaufmann) has generously provided the <em>Spim</em> documentation 
(Appendix A) from the third edition of Hennessy &amp; Patterson, <i>
<a href="http://books.elsevier.com/us/mk/us/subindex.asp?isbn=1558606041&amp;country=United+States&amp;community=mk&amp;mscssid=T3GQV69C1T2T8NHKQJH2H7ANRW84FXW3">
Computer Organization and Design: The Hardware/Software Interface</a></i>. This 
documentation is included with <em>QtSpim</em>. It is more complete and up-to-date 
than the documentation included in the old <em>Spim</em> distribution. The COD documentation 
includes:</p>
<ul>
	<li>
	<p><i>Appendix A: Assemblers, Linkers, and the SPIM Simulator</i> (<a href="HP_AppA.pdf">PDF</a>). 
	An overview and reference manual for <em>Spim</em> and the MIPS32 instruction 
	set.</p>
	</li>
	<li>
	<p><i>Getting Started with spim</i> (<a href="spim.pdf">PDF</a>). Overview of 
	the console version of <em>Spim</em> (both Unix and Windows).</p>
	</li>
	<li>
	<p><i>Getting Started with xspim</i> (<a href="xspim.pdf">PDF</a>). Overview 
	of the X-windows version of <em>Spim</em> .</p>
	</li>
	<li>
	<p><i>Getting Starting with PCSpim</i> (<a href="PCSpim.pdf">PDF</a>). Overview 
	of the Microsoft Windows version of <em>Spim</em> .</p>
	</li>
	<li>
	<p><i>SPIM Command-Line Options</i> (<a href="SPIM_command-line.pdf">PDF</a>). 
	Overview of the command line options of <em>Spim</em> (all versions).</p>
	</li>
</ul>
<p>The documentation included with <em>Spim</em> is also online
(http://spimsimulator.sourceforge.net/HP_AppA.pdf).</p>
<p>The best book I have seen on MIPS programming is: Dominic Sweetman, <i>
<a href="http://books.elsevier.com/us/mk/us/subindex.asp?isbn=1558604103&amp;country=United+States&amp;community=mk&amp;mscssid=T3GQV69C1T2T8NHKQJH2H7ANRW84FXW3">
See MIPS Run,</a></i> Morgan Kaufmann, San Francisco, CA, 1999, ISBN 1-55860-410-3.</p>
<p>MIPS, Inc. has excellent free documentation on the MIPS32 architecture on their 
website
<a href="http://www.mips.com/products/product-materials/processor/mips-architecture/">
http://www.mips.com/products/product-materials/processor/mips-architecture/</a>:
</p>
<ul>
	<li>
	<p>
	<a href="http://www.mips.com/secure-download/index.cfm?filename=mips-architecture/MD00082-2B-MIPS32INT-AFP-02_60.pdf">
	MIPS32® Architecture for Programmers Volume I: Introduction to the MIPS32® Architecture 
	(.pdf)</a> </p>
	</li>
	<li>
	<p>
	<a href="http://www.mips.com/secure-download/index.cfm?filename=mips-architecture/MD00086-2B-MIPS32BIS-AFP-02_62.pdf">
	MIPS32® Architecture for Programmers Volume II: The MIPS32® Instruction Set 
	(.pdf)</a> </p>
	</li>
	<li>
	<p>
	<a href="http://www.mips.com/secure-download/index.cfm?filename=mips-architecture/MD00090-2B-MIPS32PRA-AFP-02.80.pdf">
	MIPS32® Architecture for Programmers Volume III: The MIPS32® Privileged Resource 
	Architecture (.pdf)</a> </p>
	</li>
</ul>
<p>An old reference manual for the MIPS architecture (including processors subsequent 
to the R2000/R3000) is: Gerry Kane and Joe Heinrich, <i>MIPS RISC Architecture</i>, 
Prentice Hall, Englewood Cliffs, N.J. 07632 ISBN 0-13-1059254. </p>
<p>Another good book for the MIPS R2000 and R3000 is: Erin Farquhar and Philip Bunce,
<i>
<a href="http://books.elsevier.com/us/mk/us/subindex.asp?isbn=1558602976&amp;country=United+States&amp;community=mk&amp;mscssid=T3GQV69C1T2T8NHKQJH2H7ANRW84FXW3">
The MIPS Programmer&#39;s Handbook,</a></i> Morgan Kaufmann, San Francisco, CA, 1994, 
ISBN 1-55860-297-6.</p>
<p>The GNU C compiler can generate code for the MIPS R3000 and can be used as a 
cross compiler. A retargeted port of gcc is available on the
<a href="http://www.cs.unibo.it/mps/">MPS Resource Page</a>. I have not used this 
compiler.</p>
<p>Downcast Systems offers a very nice text editor for MIPS assembly code called
<a href="http://www.downcastsystems.com/mipster/">MIPSter</a>. It has syntax highlight, 
MIPS-specific help, good integration with SPIM, and a number of other features to 
make it easier to write assembly code. MIPSter is an inexpensive commercial product, 
and it offers a limited time trial version.</p>
<p>Andrea Grandi ported SPIM to the <a href="http://www.nokiausa.com/770">Nokia 
770/800 Internet Tablet</a>, so you never need to be without the ability to run 
MIPS programs. The port of SPIM is available at:
<a href="http://www.ptlug.org/wiki/SPIM_N770">http://www.ptlug.org/wiki/SPIM_N770</a>.
</p>

</body>

</html>
